
var start = moment().subtract(29, 'days');
var end = moment();
var id;
var selectedProductData = undefined;
var dateArray = undefined;

var manufacturing_Order_number = undefined;
var customer_order_plan_id = undefined;
var delivery_date = undefined;
var customer_order_plan_data_id = undefined;

$('#btnSave').prop('disabled', true);


$('#dashboard-daterangepicker').daterangepicker({
    startDate: start,
    endDate: end,
    opens: 'right',
    ranges: {
        'Today': [moment(), moment()],
        'Yesterday': [moment().subtract(1, 'days'), moment().subtract(1, 'days')],
        'Last 7 Days': [moment().subtract(6, 'days'), moment()],
        'Last 30 Days': [moment().subtract(29, 'days'), moment()],
        'This Month': [moment().startOf('month'), moment().endOf('month')],
        'Last Month': [moment().subtract(1, 'month').startOf('month'), moment().subtract(1, 'month').endOf('month')]
    }
});

$('#dashboard-daterangepicker span').html(start.format('MMMM D, YYYY') + ' - ' + end.format('MMMM D, YYYY'));



$('#dashboard-daterangepicker').on('apply.daterangepicker', function (ev, picker) {
    $('#dashboard-daterangepicker span').html(picker.startDate.format('MMMM D, YYYY') + ' - ' + picker.endDate.format('MMMM D, YYYY'));
    crateDateRangeTable();
});




$(document).ready(function () {

    var orderPlanTable = $('#tblMachine').DataTable({
        responsive: false,
        sScrollY: "200px",
        sScrollX: "100%",
        paging: false,
        searching: false,
        "order": [],
        "columns": [
            { "data": "name" },
            { "data": "action" },
        ],
        columnDefs: [
            { width: 80, targets: 1 },
        ],
    });

    $('#table2').DataTable({
        "pageLength": 50,
        responsive: false,
        paging: true,
        searching: true,
        "order": [],
        "columns": [
            { "data": "date" },
            { "data": "product_id" },
            { "data": "product_name" },
            { "data": "planed_day_quantity" },
            { "data": "planed_night_quantity" },
            { "data": "day_quantity" },
            { "data": "night_quantity" },

        ],
        columnDefs: [
            { width: 100, targets: 0 },
            { width: 150, targets: 1 },
            { width: 100, targets: 3 },
            { width: 100, targets: 4 },
        ],
    });

    $("#cmbSite").change(function () {
        loadMachinesTosite(this.value);
    });


    loadsite();




    $('#tblMachine tbody').on('click', 'tr', function () {

        if ($(this).hasClass('selected')) {
            $(this).removeClass('selected');
        }
        else {
            orderPlanTable.$('tr.selected').removeClass('selected');
            $(this).addClass('selected');
        }
    });







    var productOrderTable = $('#ProductOrderTable').DataTable({
        responsive: true,
        paging: true,
        searching: true,
        scrollX: true,
        "order": [],
        "columns": [
            { "data": "customer_order_plan_data_id" },
            { "data": "start_date" },
            { "data": "end_date" },
            { "data": "product_id" },
            { "data": "product_name" },
            { "data": "quantity" },
            { "data": "planed" },
            { "data": "day_night" },

        ],
        columnDefs: [
            { width: 50, targets: 1 },
            { width: 50, targets: 2 },
            { width: 100, targets: 4 },
            { width: 50, targets: 6 },
        ],
    });

    var orderPlanTable = $('#OrderPlanTable').DataTable({
        responsive: true,
        paging: true,
        searching: true,
        "order": [],
        "columns": [
            { "data": "customer_order_plan_id" },
            { "data": "manufacturing_Order_number" },
            { "data": "order_id" },
            { "data": "trans_date" },
            { "data": "delivery_date" },


        ],
        columnDefs: [
            { width: 100, targets: 0, "visible": false },
            { width: 100, targets: 1 },
            { width: 100, targets: 2 },
            { width: 100, targets: 3 },
            { width: 100, targets: 4 },
        ],
    });



    $('#tblPlanedModalData').DataTable({
        responsive: false,
        paging: false,
        searching: false,
        scrollX: true,
        "order": [],
        "columns": [
            { "data": "manufacturing_Order_number" },
            { "data": "customer_order_number" },
            { "data": "product_id" },
            { "data": "product_name" },
            { "data": "day_quantity" },
            { "data": "night_quantity" },
            { "data": "view" },


        ],
        columnDefs: [
            { width: 100, targets: 0 },
            { width: 100, targets: 1 },
            { width: 100, targets: 2 },
            { width: 100, targets: 4 },
            { width: 100, targets: 5 },
            { width: 100, targets: 6 },
        ],
    });



    $('#OrderPlanTable tbody').on('click', 'tr', function () {

        if ($(this).hasClass('selected')) {
            $(this).removeClass('selected');
        }
        else {
            orderPlanTable.$('tr.selected').removeClass('selected');
            $(this).addClass('selected');

            var rowData = orderPlanTable.row(this).data();
            manufacturing_Order_number = rowData.manufacturing_Order_number;
            customer_order_plan_id = rowData.customer_order_plan_id;
            $('#lblManufacturingOrder').text('Manufacturing Order No :' + manufacturing_Order_number);
            $('#lblCustomerOrder').text('Customer Order No :' + rowData.order_id);
            $('#lblDeliveryDate').text('Delivery Date :' + rowData.delivery_date);
            $('#pills-product-tab').trigger('click');
            getOrderPlanData(customer_order_plan_id);



        }
    });



    $('#ProductOrderTable tbody').on('click', 'tr', function () {

        if ($(this).hasClass('selected')) {
            $(this).removeClass('selected');
            var dom_nodes = $($.parseHTML(selectedProductData.day_night));
            $('#' + dom_nodes.attr('id')).prop('checked', false);
            selectedProductData = undefined;

        }
        else {
            productOrderTable.$('tr.selected').removeClass('selected');
            $(this).addClass('selected');
            selectedProductData = productOrderTable.row(this).data();
            editMachineryPlan();

        }
    });



    $('#cmbMachine').on('change', function (event) {
        loadMachineryPlan();
    });


    $('#btnAssign').on('click', function () {
        if ($('#cmbMachine').val()) {
            showModal();
        } else {
            showWarningMessage('Please select Machine...!');
        }
    });



    //crateDateRangeTable();


    $('#btnAssignOrderProduct').on('click', function () {

        var startDate = $('#dashboard-daterangepicker').data('daterangepicker').startDate.format('YYYY-MM-DD');
        var endDate = $('#dashboard-daterangepicker').data('daterangepicker').endDate.format('YYYY-MM-DD');

        if (selectedProductData != undefined) {
            var dom_nodes = $($.parseHTML(selectedProductData.day_night));

            customer_order_plan_data_id = selectedProductData.customer_order_plan_data_id;
            var start_date = selectedProductData.start_date;
            var end_date = selectedProductData.end_date;
            var id = selectedProductData.product_id;
            var name = selectedProductData.product_name;
            var quantity = selectedProductData.quantity;
            var day_night = $('#' + dom_nodes.attr('id')).prop('checked');


            if (!(getJulianDate(new Date(startDate)) <= getJulianDate(new Date(start_date)) && getJulianDate(new Date(endDate)) >= getJulianDate(new Date(end_date)))) {
                showWarningMessage("Invalied date range...!");
                return;
            }

            $.ajax({
                type: 'GET',
                url: '/pp/productionPlanMachineWise/createSchedule/' + start_date + "/" + end_date + "/" + quantity + "/" + day_night,
                async: false,
                success: function (response) {
                    console.log(response);
                    if (dateArray != undefined) {

                        var data = [];
                        for (i = 0; i < dateArray.length; i++) {
                            var dd = dateArray[i]['dd'];
                            var type = dateArray[i]['type'];

                            var date = '<label>' + dd + '</label>';
                            var planed_day_qty = '<label style="max-width: 100px;">0</label>';
                            var planed_night_qty = '<label style="max-width: 100px;">0</label>';
                            var day_qty = '<input style="max-width: 100px;" type="text" value="0">';
                            var night_qty = '<input style="max-width: 100px;" type="text" value="0">';
                            if (type == "holyday") {
                                date = '<label style="color:red;">' + dd + '</label>';
                                planed_day_qty = '<label style="max-width: 100px;">0</label>';
                                planed_night_qty = '<label style="max-width: 100px;">0</label>';
                                day_qty = '<input style="max-width: 100px;color:red;" type="text" value="0">';
                                night_qty = '<input style="max-width: 100px;color:red;" type="text" value="0">';
                            }
                            data.push({
                                "date": date,
                                "product_id": '',
                                "product_name": '',
                                "planed_day_quantity": planed_day_qty,
                                "planed_night_quantity": planed_night_qty,
                                "day_quantity": day_qty,
                                "night_quantity": night_qty,
                            });
                        }


                        for (var i = 0; i < dateArray.length; i++) {

                            for (var i2 = 0; i2 < response.result.length; i2++) {
                                console.log(dateArray[i]['dd'] + " - " + response.result[i2]['date']);
                                if (dateArray[i]['dd'] == response.result[i2]['date'] && dateArray[i]['type'] == 'week_day') {
                                    data[i]['product_id'] = '<label>' + id + '</label>';
                                    data[i]['product_name'] = '<label>' + name + '</label>';
                                    data[i]['planed_day_quantity'] = '<label id="planed_day-' + dateArray[i]['dd'] + '" style="max-width: 100px;" >0</label>';
                                    data[i]['planed_night_quantity'] = '<label id="planed_night-' + dateArray[i]['dd'] + '"  style="max-width: 100px;">0</label>';
                                    data[i]['day_quantity'] = '<input id="day-' + dateArray[i]['dd'] + '" style="max-width: 100px;" type="text" value="' + parseFloat(response.result[i2]['day_quantity']).toFixed(0) + '">';
                                    data[i]['night_quantity'] = '<input id="night-' + dateArray[i]['dd'] + '"  style="max-width: 100px;" type="text" value="' + parseFloat(response.result[i2]['night_quantity']).toFixed(0) + '">';
                                    break;
                                } else if (dateArray[i]['dd'] == response.result[i2]['date'] && dateArray[i]['type'] == 'holyday') {
                                    data[i]['product_id'] = '<label style="color:red;">' + id + '</label>';
                                    data[i]['product_name'] = '<label style="color:red;">' + name + '</label>';
                                    data[i]['planed_day_quantity'] = '<label id="planed_day-' + dateArray[i]['dd'] + '" style="max-width: 100px;">0</label>';
                                    data[i]['planed_night_quantity'] = '<label id="planed_night-' + dateArray[i]['dd'] + '"  style="max-width: 100px;">0</label>';
                                    data[i]['day_quantity'] = '<input id="day-' + dateArray[i]['dd'] + '" style="max-width: 100px;color:red;" type="text" value="0">';
                                    data[i]['night_quantity'] = '<input id="night-' + dateArray[i]['dd'] + '"  style="max-width: 100px;color:red;" type="text" value="0">';
                                    break;
                                }
                            }
                        }







                        var table = $('#table2').DataTable();
                        table.clear();
                        table.rows.add(data).draw();
                        $('#addMachineModal').modal('hide');
                        $('#btnSave').prop('disabled', false);

                    }


                },
                error: function (data) {

                },
                complete: function () {

                }
            });

        } else {
            showWarningMessage('Please select a product..!');
        }

    });


    $('#btnSave').on('click', function () {
        if ($(this).text() == 'Save') {
            save();
        } else if ($(this).text() == 'Update') {
            updateMachineryPlan();
        }

    });

});
function loadsite() {
    $.ajax({
        type: 'GET',
        url: '/pp/productionPlanMachineWise/loadsite',
        async: false,
        success: function (response) {
            console.log(response.data.result);
            if (response.data.success) {

                var html = '';
                $.each(response.data.result, function (index, value) {
                    html += '<option value="' + value.site_id + '">' + value.site + '</option>';
                    //console.log(html);
                })
                $('#cmbSite').html(html);
            }
        },
        error: function (data) {

        },
        complete: function () {

        }
    });
}
function loadMachinesTosite(id) {
    $.ajax({
        type: 'GET',
        url: '/pp/productionPlanMachineWise/loadMachinesTosite/' + id,
        success: function (response) {
            console.log(response.result)
            if (response.success) {

                document.getElementById("cmbMachine").options.length = 0;
                $('#cmbMachine').append('<option selected disabled>--Select Here--</option>');
                for (i = 0; i < response.result.length; i++) {
                    var id = response.result[i]['machinery_id'];
                    var no = response.result[i]['machinery_no'];
                    var name = response.result[i]['machinery_name'];
                    var nn = no + "-" + name;
                    $('#cmbMachine').append('<option value="' + id + '">' + nn + '</option>');                }


            }
        }, error: function (data) {
            console.log('something went wrong');
        }
    });
}




function showModal() {
    $('#addMachineModal').modal('toggle');
    $('#pills-order-tab').trigger('click');

    var data = [];
    data.push({
        "customer_order_plan_data_id": '',
        "start_date": '',
        "end_date": '',
        "product_id": '',
        "product_name": '',
        "quantity": '',
        "planed": '',
        "day_night": '',

    });


    var table = $('#ProductOrderTable').DataTable();
    table.clear();
    table.rows.add(data).draw();
    allOrderPlan();
}



function allOrderPlan() {

    $.ajax({
        type: "GET",
        url: "/pp/customerPlan/allOrderPlan",
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);

            manufacturing_Order_number = undefined;
            if (response.data.success) {
                var data = [];
                for (i = 0; i < response.data.result.length; i++) {
                    var id = response.data.result[i]['customer_order_plan_id'];
                    var order_id = response.data.result[i]['order_id'];
                    var trans_date = response.data.result[i]['trans_date'];
                    var delivery_date = response.data.result[i]['trans_date'];
                    var from_date = response.data.result[i]['from_date'];
                    var to_date = response.data.result[i]['to_date'];
                    var description = response.data.result[i]['description'];
                    var manufacturing_order_number = response.data.result[i]['manufacturing_order_number'];
                    var purchase_order = response.data.result[i]['purchase_order'];
                    //var quantity_pieces = response.data.result[i]['quantity_pieces'];


                    var string_id = "'" + id + "'";
                    data.push({
                        "customer_order_plan_id": id,
                        "manufacturing_Order_number": manufacturing_order_number,
                        "order_id": purchase_order,
                        "trans_date": trans_date,
                        "delivery_date": delivery_date,

                    });
                }


                var table = $('#OrderPlanTable').DataTable();
                table.clear();
                table.rows.add(data).draw();


            } else {
                showErrorMessage();
            }
        },
        error: function (error) {
            console.log(error);
            showErrorMessage();

        },
        complete: function () {

        }

    });

}




function getOrderPlanData(order_id) {

    $.ajax({
        type: "GET",
        url: "/pp/ProductionPlanMachineWise/allOrderPlanData/" + order_id,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);

            if (response.data.success) {
                var data = [];
                var disable = { 0: "", 1: "checked" }
                for (i = 0; i < response.data.result.length; i++) {
                    var id = response.data.result[i]['customer_order_plan_data_id'];
                    var start_date = response.data.result[i]['start_date'];
                    var end_date = response.data.result[i]['end_date'];
                    var product_id = response.data.result[i]['product_id'];
                    var product_name = response.data.result[i]['product_name'];
                    var quantity = response.data.result[i]['quantity'];
                    var planed = response.data.result[i]['planed'];
                    var day_night = '<input type="checkbox" id="' + id + '" name="dayNight" value="' + id + '">';
                    var string_id = "'" + id + "'";
                    data.push({
                        "customer_order_plan_data_id": id,
                        "start_date": start_date,
                        "end_date": end_date,
                        "product_id": product_id,
                        "product_name": product_name,
                        "quantity": quantity,
                        "planed": planed,
                        "day_night": day_night,

                    });
                }


                var table = $('#ProductOrderTable').DataTable();
                table.clear();
                table.rows.add(data).draw();


            } else {
                showErrorMessage();
            }
        },
        error: function (error) {
            console.log(error);
            showErrorMessage();

        },
        complete: function () {

        }

    });

}


function crateDateRangeTable() {
    var start_date = new Date($('#dashboard-daterangepicker').data('daterangepicker').startDate).toISOString().split('T')[0];
    var end_date = new Date($('#dashboard-daterangepicker').data('daterangepicker').endDate).toISOString().split('T')[0];


    $.ajax({
        type: "GET",
        url: "/pp/ProductionPlanMachineWise/dateRange/" + start_date + "/" + end_date,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            dateArray = response.result;

            var data = [];
            for (i = 0; i < dateArray.length; i++) {
                var dd = dateArray[i]['dd'];
                var type = dateArray[i]['type'];

                var date = '<label>' + dd + '</label>';
                var planed_day_qty = '<label style="max-width: 100px;">0</label>';
                var planed_night_qty = '<label style="max-width: 100px;">0</label>';
                var day_qty = '<input style="max-width: 100px;" type="text" value="0">';
                var night_qty = '<input style="max-width: 100px;" type="text" value="0">';
                if (type == "holyday") {
                    date = '<label style="color:red;">' + dd + '</label>';
                    planed_day_qty = '<label style="max-width: 100px;color:red;">0</label>';
                    planed_night_qty = '<label style="max-width: 100px;color:red;">0</label>';
                    day_qty = '<input style="max-width: 100px;color:red;" type="text" value="0">';
                    night_qty = '<input style="max-width: 100px;color:red;" type="text" value="0">';
                }
                data.push({
                    "date": date,
                    "product_id": '',
                    "product_name": '',
                    "planed_day_quantity": planed_day_qty,
                    "planed_night_quantity": planed_night_qty,
                    "day_quantity": day_qty,
                    "night_quantity": night_qty,
                });
            }


            var table = $('#table2').DataTable();
            table.clear();
            table.rows.add(data).draw();

            //loadMachineryPlan();


        },
        error: function (error) {
            console.log(error);
            showErrorMessage();

        },
        complete: function () {

        }

    });

}




function save() {
    var table = $('#table2').DataTable();
    var machinery_plan_data = [];
    table.rows().eq(0).each(function (index) {
        var row = table.row(index);

        var data = row.data();
        var date = $($.parseHTML(data.date)).text();
        var product_id = $($.parseHTML(data.product_id)).text();
        var product_name = $($.parseHTML(data.product_name)).text();
        var day_quantity = $('#' + $($.parseHTML(data.day_quantity)).attr('id')).val();
        var night_quantity = $('#' + $($.parseHTML(data.night_quantity)).attr('id')).val();

        if (product_id != '' && product_name != '' && customer_order_plan_data_id != undefined) {
            machinery_plan_data.push({
                "customer_order_plan_data_id": customer_order_plan_data_id,
                "machine_id": $('#cmbMachine').val(),
                "product_id": product_id,
                "date": date,
                "day_quantity": day_quantity,
                "night_quantity": night_quantity,
            });
        }



    });
    console.log(machinery_plan_data);


    $.ajax({
        type: "POST",
        url: '/pp/ProductionPlanMachineWise/saveMachineryPlan',
        data: {
            'data': machinery_plan_data,
        },
        headers: {
            'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
        },
        timeout: 800000,
        beforeSend: function () {
        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                showSuccessMessage('Mechinery Plan Data has been save success..!');
                $('#btnSave').prop('disabled', true);
                var table = $('#table2').DataTable();
                table.clear().draw();
            }

        },
        error: function (error) {
            console.log(error);
            toastr.error('Something went wrong');
        },
        complete: function () {
        }

    });
}



function loadMachineryPlan() {

    $.ajax({
        type: "GET",
        url: "/pp/customerPlanData/loadMachineryPlan/" + $('#cmbMachine').val(),
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);

            if (response.data.success) {

                if (dateArray != undefined) {

                    var data = [];
                    for (i = 0; i < dateArray.length; i++) {
                        var dd = dateArray[i]['dd'];
                        var type = dateArray[i]['type'];

                        var date = '<label>' + dd + '</label>';
                        var planed_day_qty = '<label style="max-width: 100px;">0</label>';
                        var planed_night_qty = '<label style="max-width: 100px;">0</label>';
                        var day_qty = '<input style="max-width: 100px;" type="text" value="0">';
                        var night_qty = '<input style="max-width: 100px;" type="text" value="0">';
                        if (type == "holyday") {
                            date = '<label style="color:red;">' + dd + '</label>';
                            planed_day_qty = '<label style="max-width: 100px;color:red;">0</label>';
                            planed_night_qty = '<label style="max-width: 100px;color:red;">0</label>';
                            day_qty = '<input style="max-width: 100px;color:red;" type="text" value="0">';
                            night_qty = '<input style="max-width: 100px;color:red;" type="text" value="0">';
                        }
                        data.push({
                            "date": date,
                            "product_id": '',
                            "product_name": '',
                            "planed_day_quantity": planed_day_qty,
                            "planed_night_quantity": planed_night_qty,
                            "day_quantity": day_qty,
                            "night_quantity": night_qty,
                        });
                    }


                    for (var i = 0; i < dateArray.length; i++) {

                        for (var i2 = 0; i2 < response.data.result.length; i2++) {
                            console.log(dateArray[i]['dd'] + " - " + response.data.result[i2]['date']);
                            if (dateArray[i]['dd'] == response.data.result[i2]['date'] && dateArray[i]['type'] == 'week_day') {
                                //data[i]['product_id'] = '<label>' + response.data.result[i2]['product_id'] + '</label>';
                                //data[i]['product_name'] = '<label>' + response.data.result[i2]['product_name'] + '</label>';
                                var title = "'" + "Planed Day" + "'";
                                var date = "'" + dateArray[i]['dd'] + "'";
                                var id = "'" + response.data.result[i2]['customer_order_plan_data_id'] + "'";
                                data[i]['planed_day_quantity'] = '<label class="pointer" id="day-' + dateArray[i]['dd'] + '" style="max-width: 100px;" onclick="showPlanedModal(' + title + ',' + date + ',' + id + ')">' + parseFloat(response.data.result[i2]['day_quantity']).toFixed(0) + '</label>';
                                var title = "'" + "Planed Night" + "'";
                                data[i]['planed_night_quantity'] = '<label class="pointer" id="night-' + dateArray[i]['dd'] + '"  style="max-width: 100px;" onclick="showPlanedModal(' + title + ',' + date + ',' + id + ')">' + parseFloat(response.data.result[i2]['night_quantity']).toFixed(0) + '</label>';
                                break;
                            } else if (dateArray[i]['dd'] == response.data.result[i2]['date'] && dateArray[i]['type'] == 'holyday') {
                                //data[i]['product_id'] = '<label style="color:red;">' + response.data.result[i2]['product_id'] + '</label>';
                                //data[i]['product_name'] = '<label style="color:red;">' + response.data.result[i2]['product_name'] + '</label>';
                                var title = "'" + "Planed Day" + "'";
                                var date = "'" + dateArray[i]['dd'] + "'";
                                var id = "'" + response.data.result[i2]['customer_order_plan_data_id'] + "'";
                                data[i]['planed_day_quantity'] = '<label class="pointer" id="day-' + dateArray[i]['dd'] + '" style="max-width: 100px;color:red;" onclick="showPlanedModal(' + title + ',' + date + ',' + id + ')">' + parseFloat(response.data.result[i2]['day_quantity']).toFixed(0) + '</label>';
                                var title = "'" + "Planed Night" + "'";
                                data[i]['planed_night_quantity'] = '<label class="pointer" id="night-' + dateArray[i]['dd'] + '"  style="max-width: 100px;color:red;" onclick="showPlanedModal(' + title + ',' + date + ',' + id + ')">' + parseFloat(response.data.result[i2]['night_quantity']).toFixed(0) + '</label>';
                                break;
                            }
                        }
                    }







                    var table = $('#table2').DataTable();
                    table.clear();
                    table.rows.add(data).draw();
                    $('#addMachineModal').modal('hide');

                }

            }
        },
        error: function (error) {
            console.log(error);
            showErrorMessage();

        },
        complete: function () {

        }

    });
}


function editMachineryPlan() {

    if (selectedProductData != undefined) {
        customer_order_plan_data_id = selectedProductData.customer_order_plan_data_id;
        var start_date = selectedProductData.start_date;
        var end_date = selectedProductData.end_date;
        $.ajax({
            type: 'GET',
            url: '/pp/customerPlanData/editMachineryPlan/' + customer_order_plan_data_id + '/' + start_date + '/' + end_date,
            async: false,
            success: function (response) {
                console.log(response.data.result);
                if (response.data.success) {

                    if (dateArray != undefined) {

                        var data = [];
                        for (i = 0; i < dateArray.length; i++) {
                            var dd = dateArray[i]['dd'];
                            var type = dateArray[i]['type'];

                            var date = '<label>' + dd + '</label>';
                            var planed_day_qty = '<label style="max-width: 100px;">0</label>';
                            var planed_night_qty = '<label style="max-width: 100px;">0</label>';
                            var day_qty = '<input style="max-width: 100px;" type="text" value="0">';
                            var night_qty = '<input style="max-width: 100px;" type="text" value="0">';
                            if (type == "holyday") {
                                date = '<label style="color:red;">' + dd + '</label>';
                                planed_day_qty = '<label style="max-width: 100px;color:red;">0</label>';
                                planed_night_qty = '<label style="max-width: 100px;color:red;">0</label>';
                                day_qty = '<input style="max-width: 100px;color:red;" type="text" value="0">';
                                night_qty = '<input style="max-width: 100px;color:red;" type="text" value="0">';
                            }
                            data.push({
                                "date": date,
                                "product_id": '',
                                "product_name": '',
                                "planed_day_quantity": planed_day_qty,
                                "planed_night_quantity": planed_night_qty,
                                "day_quantity": day_qty,
                                "night_quantity": night_qty,
                            });
                        }


                        for (var i = 0; i < dateArray.length; i++) {

                            for (var i2 = 0; i2 < response.data.result.length; i2++) {
                                console.log(dateArray[i]['dd'] + " - " + response.data.result[i2]['date']);
                                if (dateArray[i]['dd'] == response.data.result[i2]['date'] && dateArray[i]['type'] == 'week_day') {
                                    data[i]['product_id'] = '<label>' + response.data.result[i2]['product_id'] + '</label>';
                                    data[i]['product_name'] = '<label>' + response.data.result[i2]['product_name'] + '</label>';
                                    data[i]['day_quantity'] = '<input id="day-' + dateArray[i]['dd'] + '" style="max-width: 100px;" type="text" value="' + parseFloat(response.data.result[i2]['day_quantity']).toFixed(0) + '">';
                                    data[i]['night_quantity'] = '<input id="night-' + dateArray[i]['dd'] + '"  style="max-width: 100px;" type="text" value="' + parseFloat(response.data.result[i2]['night_quantity']).toFixed(0) + '">';
                                    break;
                                } else if (dateArray[i]['dd'] == response.data.result[i2]['date'] && dateArray[i]['type'] == 'holyday') {
                                    data[i]['product_id'] = '<label style="color:red;">' + response.data.result[i2]['product_id'] + '</label>';
                                    data[i]['product_name'] = '<label style="color:red;">' + response.data.result[i2]['product_name'] + '</label>';
                                    data[i]['day_quantity'] = '<input id="day-' + dateArray[i]['dd'] + '" style="max-width: 100px;color:red;" type="text" value="' + parseFloat(response.data.result[i2]['day_quantity']).toFixed(0) + '">';
                                    data[i]['night_quantity'] = '<input id="night-' + dateArray[i]['dd'] + '"  style="max-width: 100px;color:red;" type="text" value="' + parseFloat(response.data.result[i2]['night_quantity']).toFixed(0) + '">';
                                    break;
                                }
                            }
                        }



                        var table = $('#table2').DataTable();
                        table.clear();
                        table.rows.add(data).draw();
                        if (response.data.result.length != 0) {
                            $('#addMachineModal').modal('hide');
                            $('#btnSave').text('Update');
                            $('#btnSave').prop('disabled', false);
                        } else {
                            $('#btnSave').text('Save');
                        }

                    }

                }
            },
            error: function (data) {

            },
            complete: function () {

            }
        });
    }
}



function updateMachineryPlan() {

    var table = $('#table2').DataTable();
    var machinery_plan_data = [];
    table.rows().eq(0).each(function (index) {
        var row = table.row(index);

        var data = row.data();
        var date = $($.parseHTML(data.date)).text();
        var product_id = $($.parseHTML(data.product_id)).text();
        var product_name = $($.parseHTML(data.product_name)).text();
        var day_quantity = $('#' + $($.parseHTML(data.day_quantity)).attr('id')).val();
        var night_quantity = $('#' + $($.parseHTML(data.night_quantity)).attr('id')).val();

        if (product_id != '' && product_name != '' && customer_order_plan_data_id != undefined) {
            machinery_plan_data.push({
                "customer_order_plan_data_id": customer_order_plan_data_id,
                "machine_id": $('#cmbMachine').val(),
                "product_id": product_id,
                "date": date,
                "day_quantity": day_quantity,
                "night_quantity": night_quantity,
            });
        }
    });


    if (selectedProductData != undefined) {
        customer_order_plan_data_id = selectedProductData.customer_order_plan_data_id;
        var start_date = selectedProductData.start_date;
        var end_date = selectedProductData.end_date;

        $.ajax({
            type: "POST",
            url: '/pp/ProductionPlanMachineWise/updateMachineryPlan/' + customer_order_plan_data_id + '/' + start_date + '/' + end_date,
            data: {
                'data': machinery_plan_data,
            },
            headers: {
                'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
            },
            timeout: 800000,
            beforeSend: function () {
            },
            success: function (response) {
                console.log(response);
                if (response.data.success) {
                    showSuccessMessage('Mechinery Plan Data has been updated success..!');
                    $('#btnSave').text('Save');
                    $('#btnSave').prop('disabled', true);
                    var table = $('#table2').DataTable();
                    table.clear().draw();
                }

            },
            error: function (error) {
                console.log(error);
                toastr.error('Something went wrong');
            },
            complete: function () {
            }

        });
    }


}



function showPlanedModal(title, date, id) {


    $.ajax({
        type: "GET",
        url: "/pp/ProductionPlanMachineWise/showPlanedModalData/" + date + "/" + id,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);

            var data = [];
            for (i = 0; i < response.data.result.length; i++) {
                var customer_order_plan_data_id = response.data.result[i]['manufacturing_order_no'];
                var manufacturing_order_no = response.data.result[i]['manufacturing_order_no'];
                var customer_order_plan_id = response.data.result[i]['purchase_order'];
                var product_id = response.data.result[i]['product_id'];
                var product_name = response.data.result[i]['product_name'];
                var day_quantity = response.data.result[i]['day_quantity'];
                var night_quantity = response.data.result[i]['night_quantity'];
                var p_id = "'" + product_id + "'";
                var cus_order_plan_data_id = "'" + customer_order_plan_data_id + "'";
                var view = '<button class="btn btn-success" onclick="loadAllPlanedDataMachine(' + p_id + ',' + cus_order_plan_data_id + ');">View</button>';
                data.push({
                    "manufacturing_Order_number": manufacturing_order_no,
                    "customer_order_number": customer_order_plan_id,
                    "product_id": product_id,
                    "product_name": product_name,
                    "day_quantity": day_quantity,
                    "night_quantity": night_quantity,
                    "view": view,

                });
            }


            var table = $('#tblPlanedModalData').DataTable();
            table.clear();
            table.rows.add(data).draw();

            $('#planedModalTitle').text('Planed Data');
            $('#planedModal').modal('toggle');


        },
        error: function (error) {
            console.log(error);
            showErrorMessage();

        },
        complete: function () {

        }

    });





}







function loadAllPlanedDataMachine(product_id, customer_order_plan_data_id) {


    $.ajax({
        type: "GET",
        url: "/pp/ProductionPlanMachineWise/loadAllPlanedDataMachine/" + product_id + "/" + customer_order_plan_data_id + "/" + $('#cmbMachine').val(),
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {

                if (dateArray != undefined) {

                    var data = [];
                    for (i = 0; i < dateArray.length; i++) {
                        var dd = dateArray[i]['dd'];
                        var type = dateArray[i]['type'];

                        var date = '<label>' + dd + '</label>';
                        var planed_day_qty = '<label style="max-width: 100px;">0</label>';
                        var planed_night_qty = '<label style="max-width: 100px;">0</label>';
                        var day_qty = '<input style="max-width: 100px;" type="text" value="0">';
                        var night_qty = '<input style="max-width: 100px;" type="text" value="0">';
                        if (type == "holyday") {
                            date = '<label style="color:red;">' + dd + '</label>';
                            planed_day_qty = '<label style="max-width: 100px;color:red;">0</label>';
                            planed_night_qty = '<label style="max-width: 100px;color:red;">0</label>';
                            day_qty = '<input style="max-width: 100px;color:red;" type="text" value="0">';
                            night_qty = '<input style="max-width: 100px;color:red;" type="text" value="0">';
                        }
                        data.push({
                            "date": date,
                            "product_id": '',
                            "product_name": '',
                            "planed_day_quantity": planed_day_qty,
                            "planed_night_quantity": planed_night_qty,
                            "day_quantity": day_qty,
                            "night_quantity": night_qty,
                        });
                    }


                    for (var i = 0; i < dateArray.length; i++) {

                        for (var i2 = 0; i2 < response.data.result.length; i2++) {
                            console.log(dateArray[i]['dd'] + " - " + response.data.result[i2]['date']);
                            if (dateArray[i]['dd'] == response.data.result[i2]['date'] && dateArray[i]['type'] == 'week_day') {
                                data[i]['product_id'] = '<label>' + response.data.result[i2]['product_id'] + '</label>';
                                data[i]['product_name'] = '<label>' + response.data.result[i2]['product_name'] + '</label>';
                                data[i]['day_quantity'] = '<input id="day-' + dateArray[i]['dd'] + '" style="max-width: 100px;" type="text" value="' + parseFloat(response.data.result[i2]['day_quantity']).toFixed(0) + '">';
                                data[i]['night_quantity'] = '<input id="night-' + dateArray[i]['dd'] + '"  style="max-width: 100px;" type="text" value="' + parseFloat(response.data.result[i2]['night_quantity']).toFixed(0) + '">';
                                break;
                            } else if (dateArray[i]['dd'] == response.data.result[i2]['date'] && dateArray[i]['type'] == 'holyday') {
                                data[i]['product_id'] = '<label style="color:red;">' + response.data.result[i2]['product_id'] + '</label>';
                                data[i]['product_name'] = '<label style="color:red;">' + response.data.result[i2]['product_name'] + '</label>';
                                data[i]['day_quantity'] = '<input id="day-' + dateArray[i]['dd'] + '" style="max-width: 100px;color:red;" type="text" value="' + parseFloat(response.data.result[i2]['day_quantity']).toFixed(0) + '">';
                                data[i]['night_quantity'] = '<input id="night-' + dateArray[i]['dd'] + '"  style="max-width: 100px;color:red;" type="text" value="' + parseFloat(response.data.result[i2]['night_quantity']).toFixed(0) + '">';
                                break;
                            }
                        }
                    }



                    var table = $('#table2').DataTable();
                    table.clear();
                    table.rows.add(data).draw();
                    /*if (response.data.result.length != 0) {
                        $('#addMachineModal').modal('hide');
                        $('#btnSave').text('Update');
                        $('#btnSave').prop('disabled', false);
                    } else {
                        $('#btnSave').text('Save');
                    }*/

                }

            }



        },
        error: function (error) {
            console.log(error);
            showErrorMessage();

        },
        complete: function () {

        }

    });


}


/**
* showSuccessMessage
* This function is used to show success message.
* @param message This is the paramter to require message content
*/
function showSuccessMessage(message) {
    toastr.success(message);
}


/**
* showWarningMessage
* This function is used to show warning message.
* @param message This is the paramter to require message content
*/
function showWarningMessage(message) {
    toastr.warning(message);
}



/**
* showErrorMessage
* This function is used to show error message.
* @param message This is the paramter to require message content
*/
function showErrorMessage() {
    toastr.error('Something went wrong');
}




function getJulianDate(date) {
    var julday = Math.floor((date.valueOf() / (1000 * 60 * 60 * 24)) - 0.5) + 2440588;
    return julday;
}